DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Scheduler - Drag & Drop

Appointment drag and drop is enabled out-of-the-box, but only if appointments are moved within the JavaScript Scheduler. In this demo, appointments can be moved between the JavaScript Scheduler and a list.

Backend API
$(() => { const draggingGroupName = 'appointmentsGroup'; const createItemElement = function (data) { $('<div>') .text(data.text) .addClass('item dx-card') .appendTo('#list') .dxDraggable({ group: draggingGroupName, data, clone: true, onDragEnd(e) { if (e.toData) { e.cancel = true; } }, onDragStart(e) { e.itemData = e.fromData; }, }); }; $('#scroll').dxScrollView({}); $('#list').dxDraggable({ data: 'dropArea', group: draggingGroupName, onDragStart(e) { e.cancel = true; }, }); tasks.forEach((task) => { createItemElement(task); }); $('#scheduler').dxScheduler({ timeZone: 'America/Los_Angeles', dataSource: appointments, views: [{ type: 'day', intervalCount: 3, }], currentDate: new Date(2021, 3, 26), startDayHour: 9, height: 600, editing: true, appointmentDragging: { group: draggingGroupName, onRemove(e) { e.component.deleteAppointment(e.itemData); createItemElement(e.itemData); }, onAdd(e) { e.component.addAppointment(e.itemData); e.itemElement.remove(); }, }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="js/dx.all.js?v=26.1.4"></script> <script src="data.js"></script> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="scroll"> <div id="list"></div> </div> <div id="scheduler"></div> </div> </body> </html>
#scroll, #list { position: absolute; left: 0; top: 0; bottom: 0; width: 240px; } .item { color: var(--dx-color-text); background-color: var(--dx-component-color-bg); box-sizing: border-box; padding: 10px 20px; margin-bottom: 10px; } #scheduler { margin-left: 270px; } .dx-draggable-source { opacity: 0.5; } .dx-draggable-dragging > * { box-shadow: 0 1px 3px rgba(0, 0, 0, 0.1), 0 6px 8px rgba(0, 0, 0, 0.2); }
const tasks = [ { text: 'New Brochures', }, { text: 'Brochure Design Review', }, { text: 'Upgrade Personal Computers', }, { text: 'Install New Router in Dev Room', }, { text: 'Upgrade Server Hardware', }, { text: 'Install New Database', }, { text: 'Website Re-Design Plan', }, { text: 'Create Icons for Website', }, { text: 'Submit New Website Design', }, { text: 'Launch New Website', }, ]; const appointments = [{ text: 'Book Flights to San Fran for Sales Trip', startDate: new Date('2021-04-26T19:00:00.000Z'), endDate: new Date('2021-04-26T20:00:00.000Z'), allDay: true, }, { text: 'Approve Personal Computer Upgrade Plan', startDate: new Date('2021-04-27T17:00:00.000Z'), endDate: new Date('2021-04-27T18:00:00.000Z'), }, { text: 'Final Budget Review', startDate: new Date('2021-04-27T19:00:00.000Z'), endDate: new Date('2021-04-27T20:35:00.000Z'), }, { text: 'Approve New Online Marketing Strategy', startDate: new Date('2021-04-28T19:00:00.000Z'), endDate: new Date('2021-04-28T21:00:00.000Z'), }, { text: 'Customer Workshop', startDate: new Date('2021-04-29T18:00:00.000Z'), endDate: new Date('2021-04-29T19:00:00.000Z'), allDay: true, }, { text: 'Prepare 2021 Marketing Plan', startDate: new Date('2021-04-29T18:00:00.000Z'), endDate: new Date('2021-04-29T20:30:00.000Z'), }];

Follow the steps below to implement this functionality:

  1. Configure the JavaScript Scheduler
    In the appointmentDragging object, implement the onAdd function (in which you should add an appointment) and the onRemove function (in which you should delete an appointment and create a corresponding list item).

  2. Configure list items
    Attach an instance of the Draggable component to every list item. The component has the data property that can contain custom data. In this demo, it is an appointment's subject. Implement the onDragStart function in which you should pass the subject to the JavaScript Scheduler where it is used to add new appointments.

  3. Configure the list
    Attach another Draggable instance to the list which only serves as the drop target. Implement the onDragStart function to ensure the list cannot be dragged.

  4. Add the controls to the same group
    To enable drag and drop operations between the controls, assign the same value to the group property of the JavaScript Scheduler's appointmentDragging object and both Draggable components.

import React, { useCallback, useState } from 'react';
import Scheduler, { AppointmentDragging } from 'devextreme-react/scheduler';
import type { SchedulerTypes } from 'devextreme-react/scheduler';
import Draggable from 'devextreme-react/draggable';
import type { DraggableTypes } from 'devextreme-react/draggable';
import ScrollView from 'devextreme-react/scroll-view';
import { appointments as defaultAppointments, tasks as defaultTasks } from './data.ts';
import type { Task } from './data.ts';
const currentDate = new Date(2021, 3, 26);
const views: SchedulerTypes.Properties['views'] = [{ type: 'day', intervalCount: 3 }];
const draggingGroupName = 'appointmentsGroup';
const onListDragStart = (e: DraggableTypes.DragStartEvent) => {
e.cancel = true;
};
const onItemDragStart = (e: DraggableTypes.DragStartEvent) => {
e.itemData = e.fromData;
};
const onItemDragEnd = (e: DraggableTypes.DragEndEvent) => {
if (e.toData) {
e.cancel = true;
}
};
const App = () => {
const [state, setState] = useState({
tasks: defaultTasks, appointments: defaultAppointments,
});
const onAppointmentRemove = useCallback((e: SchedulerTypes.AppointmentDraggingRemoveEvent) => {
setState((currentState: { appointments: SchedulerTypes.Appointment[]; tasks: Task[]; }) => {
const { appointments, tasks } = currentState;
const index = appointments.indexOf(e.itemData);
if (index >= 0) {
tasks.push(e.itemData);
appointments.splice(index, 1);
}
return { appointments: [...appointments], tasks: [...tasks] };
});
}, []);
const onAppointmentAdd = useCallback((e: SchedulerTypes.AppointmentDraggingAddEvent) => {
setState((currentState: { appointments: SchedulerTypes.Appointment[]; tasks: Task[]; }) => {
const { appointments, tasks } = currentState;
const index = tasks.indexOf(e.fromData);
if (index >= 0) {
tasks.splice(index, 1);
appointments.push(e.itemData);
}
return { appointments: [...appointments], tasks: [...tasks] };
});
}, []);
return (
<>
<ScrollView id="scroll">
<Draggable
id="list"
data="dropArea"
group={draggingGroupName}
onDragStart={onListDragStart}>
{state.tasks.map((task) => (
<Draggable
key={task.text}
className="item dx-card"
clone={true}
group={draggingGroupName}
data={task}
onDragStart={onItemDragStart}
onDragEnd={onItemDragEnd}
>
{task.text}
</Draggable>
))}
</Draggable>
</ScrollView>
<Scheduler
id="scheduler"
timeZone="America/Los_Angeles"
dataSource={state.appointments}
views={views}
defaultCurrentDate={currentDate}
height={600}
startDayHour={9}
editing={true}
>
<AppointmentDragging
group={draggingGroupName}
onRemove={onAppointmentRemove as any}
onAdd={onAppointmentAdd as any}
/>
</Scheduler>
</>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import Scheduler, { AppointmentDragging } from 'devextreme-react/scheduler';
import Draggable from 'devextreme-react/draggable';
import ScrollView from 'devextreme-react/scroll-view';
import { appointments as defaultAppointments, tasks as defaultTasks } from './data.js';
const currentDate = new Date(2021, 3, 26);
const views = [{ type: 'day', intervalCount: 3 }];
const draggingGroupName = 'appointmentsGroup';
const onListDragStart = (e) => {
e.cancel = true;
};
const onItemDragStart = (e) => {
e.itemData = e.fromData;
};
const onItemDragEnd = (e) => {
if (e.toData) {
e.cancel = true;
}
};
const App = () => {
const [state, setState] = useState({
tasks: defaultTasks,
appointments: defaultAppointments,
});
const onAppointmentRemove = useCallback((e) => {
setState((currentState) => {
const { appointments, tasks } = currentState;
const index = appointments.indexOf(e.itemData);
if (index >= 0) {
tasks.push(e.itemData);
appointments.splice(index, 1);
}
return { appointments: [...appointments], tasks: [...tasks] };
});
}, []);
const onAppointmentAdd = useCallback((e) => {
setState((currentState) => {
const { appointments, tasks } = currentState;
const index = tasks.indexOf(e.fromData);
if (index >= 0) {
tasks.splice(index, 1);
appointments.push(e.itemData);
}
return { appointments: [...appointments], tasks: [...tasks] };
});
}, []);
return (
<>
<ScrollView id="scroll">
<Draggable
id="list"
data="dropArea"
group={draggingGroupName}
onDragStart={onListDragStart}
>
{state.tasks.map((task) => (
<Draggable
key={task.text}
className="item dx-card"
clone={true}
group={draggingGroupName}
data={task}
onDragStart={onItemDragStart}
onDragEnd={onItemDragEnd}
>
{task.text}
</Draggable>
))}
</Draggable>
</ScrollView>
<Scheduler
id="scheduler"
timeZone="America/Los_Angeles"
dataSource={state.appointments}
views={views}
defaultCurrentDate={currentDate}
height={600}
startDayHour={9}
editing={true}
>
<AppointmentDragging
group={draggingGroupName}
onRemove={onAppointmentRemove}
onAdd={onAppointmentAdd}
/>
</Scheduler>
</>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { SchedulerTypes } from 'devextreme-react/scheduler';
export type Task = {
text: string;
};
export const tasks: Task[] = [
{
text: 'New Brochures',
}, {
text: 'Brochure Design Review',
}, {
text: 'Upgrade Personal Computers',
}, {
text: 'Install New Router in Dev Room',
}, {
text: 'Upgrade Server Hardware',
}, {
text: 'Install New Database',
}, {
text: 'Website Re-Design Plan',
}, {
text: 'Create Icons for Website',
}, {
text: 'Submit New Website Design',
}, {
text: 'Launch New Website',
},
];
export const appointments: SchedulerTypes.Appointment[] = [
{
text: 'Book Flights to San Fran for Sales Trip',
startDate: new Date('2021-04-26T19:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
allDay: true,
}, {
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date('2021-04-27T17:00:00.000Z'),
endDate: new Date('2021-04-27T18:00:00.000Z'),
}, {
text: 'Final Budget Review',
startDate: new Date('2021-04-27T19:00:00.000Z'),
endDate: new Date('2021-04-27T20:35:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
startDate: new Date('2021-04-28T19:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
}, {
text: 'Customer Workshop',
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T19:00:00.000Z'),
allDay: true,
}, {
text: 'Prepare 2021 Marketing Plan',
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T20:30:00.000Z'),
},
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const tasks = [
{
text: 'New Brochures',
},
{
text: 'Brochure Design Review',
},
{
text: 'Upgrade Personal Computers',
},
{
text: 'Install New Router in Dev Room',
},
{
text: 'Upgrade Server Hardware',
},
{
text: 'Install New Database',
},
{
text: 'Website Re-Design Plan',
},
{
text: 'Create Icons for Website',
},
{
text: 'Submit New Website Design',
},
{
text: 'Launch New Website',
},
];
export const appointments = [
{
text: 'Book Flights to San Fran for Sales Trip',
startDate: new Date('2021-04-26T19:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
allDay: true,
},
{
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date('2021-04-27T17:00:00.000Z'),
endDate: new Date('2021-04-27T18:00:00.000Z'),
},
{
text: 'Final Budget Review',
startDate: new Date('2021-04-27T19:00:00.000Z'),
endDate: new Date('2021-04-27T20:35:00.000Z'),
},
{
text: 'Approve New Online Marketing Strategy',
startDate: new Date('2021-04-28T19:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
},
{
text: 'Customer Workshop',
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T19:00:00.000Z'),
allDay: true,
},
{
text: 'Prepare 2021 Marketing Plan',
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T20:30:00.000Z'),
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#scroll,
#list {
position: absolute;
left: 0;
top: 0;
bottom: 0;
width: 240px;
}
.item {
color: var(--dx-color-text);
background-color: var(--dx-component-color-bg);
box-sizing: border-box;
padding: 10px 20px;
margin-bottom: 10px;
}
#scheduler {
margin-left: 270px;
}
.dx-draggable-source {
opacity: 0.5;
}
.dx-draggable-dragging > * {
box-shadow: 0 1px 3px rgba(0, 0, 0, 0.1), 0 6px 8px rgba(0, 0, 0, 0.2);
}

<template>
<div id="demo-container">
<DxScrollView id="scroll">
<DxDraggable
id="list"
:group="draggingGroupName"
:on-drag-start="onListDragStart"
data="dropArea"
>
<DxDraggable
v-for="task in tasks"
:key="task.text"
:clone="true"
:group="draggingGroupName"
:data="task"
:on-drag-start="onItemDragStart"
:on-drag-end="onItemDragEnd"
class="item dx-card"
>
{{ task.text }}
</DxDraggable>
</DxDraggable>
</DxScrollView>
<DxScheduler
time-zone="America/Los_Angeles"
id="scheduler"
:data-source="appointments"
:current-date="currentDate"
:views="views"
:height="600"
:start-day-hour="9"
:editing="true"
>
<DxAppointmentDragging
:group="draggingGroupName"
:on-remove="onAppointmentRemove"
:on-add="onAppointmentAdd"
/>
</DxScheduler>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxScheduler, { DxAppointmentDragging, type DxSchedulerTypes } from 'devextreme-vue/scheduler';
import DxDraggable, { type DxDraggableTypes } from 'devextreme-vue/draggable';
import DxScrollView from 'devextreme-vue/scroll-view';
import { appointments as appointmentsData, tasks as tasksData, type Task } from './data.ts';
const draggingGroupName = ref('appointmentsGroup');
const views = ref([{ type: 'day', intervalCount: 3 }]);
const currentDate = ref(new Date(2021, 3, 26));
const tasks = ref<Task[]>(tasksData);
const appointments = ref<DxSchedulerTypes.Appointment[]>(appointmentsData);
function onAppointmentRemove({ itemData }: any) {
const index = appointments.value.indexOf(itemData);
if (index >= 0) {
appointments.value = [...appointments.value];
appointments.value.splice(index, 1);
tasks.value = [...tasks.value, itemData];
}
}
function onAppointmentAdd(e: any) {
const index = tasks.value.indexOf(e.fromData);
if (index >= 0) {
tasks.value = [...tasks.value];
tasks.value.splice(index, 1);
appointments.value = [...appointments.value, e.itemData];
}
}
function onListDragStart(e: DxDraggableTypes.DragStartEvent) {
e.cancel = true;
}
function onItemDragStart(e: DxDraggableTypes.DragStartEvent) {
e.itemData = e.fromData;
}
function onItemDragEnd(e: DxDraggableTypes.DragEndEvent) {
if (e.toData) {
e.cancel = true;
}
}
</script>
<style>
#scroll,
#list {
position: absolute;
left: 0;
top: 0;
bottom: 0;
width: 240px;
}
.item {
color: var(--dx-color-text);
background-color: var(--dx-component-color-bg);
box-sizing: border-box;
padding: 10px 20px;
margin-bottom: 10px;
}
#scheduler {
margin-left: 270px;
}
.dx-draggable-source {
opacity: 0.5;
}
.dx-draggable-dragging > * {
box-shadow: 0 1px 3px rgba(0, 0, 0, 0.1), 0 6px 8px rgba(0, 0, 0, 0.2);
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export interface Task {
text: string;
}
export const tasks: Task[] = [
{
text: 'New Brochures',
}, {
text: 'Brochure Design Review',
}, {
text: 'Upgrade Personal Computers',
}, {
text: 'Install New Router in Dev Room',
}, {
text: 'Upgrade Server Hardware',
}, {
text: 'Install New Database',
}, {
text: 'Website Re-Design Plan',
}, {
text: 'Create Icons for Website',
}, {
text: 'Submit New Website Design',
}, {
text: 'Launch New Website',
},
];
export const appointments = [
{
text: 'Book Flights to San Fran for Sales Trip',
startDate: new Date('2021-04-26T19:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
allDay: true,
}, {
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date('2021-04-27T17:00:00.000Z'),
endDate: new Date('2021-04-27T18:00:00.000Z'),
}, {
text: 'Final Budget Review',
startDate: new Date('2021-04-27T19:00:00.000Z'),
endDate: new Date('2021-04-27T20:35:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
startDate: new Date('2021-04-28T19:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
}, {
text: 'Customer Workshop',
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T19:00:00.000Z'),
allDay: true,
}, {
text: 'Prepare 2021 Marketing Plan',
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T20:30:00.000Z'),
},
];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

<dx-scroll-view id="scroll">
<dx-draggable
id="list"
data="dropArea"
[group]="draggingGroupName"
(onDragStart)="onListDragStart($event)"
>
@for (task of tasks; track task.text) {
<dx-draggable
class="item dx-card"
[clone]="true"
[group]="draggingGroupName"
[data]="task"
(onDragStart)="onItemDragStart($event)"
(onDragEnd)="onItemDragEnd($event)"
>
{{ task.text }}
</dx-draggable>
}
</dx-draggable>
</dx-scroll-view>
<dx-scheduler
timeZone="America/Los_Angeles"
id="scheduler"
[dataSource]="appointments"
[currentDate]="currentDate"
[startDayHour]="9"
[height]="600"
[editing]="true"
>
<dxi-scheduler-view type="day" [intervalCount]="3"> </dxi-scheduler-view>
<dxo-scheduler-appointment-dragging
[group]="draggingGroupName"
[onRemove]="onAppointmentRemove"
[onAdd]="onAppointmentAdd"
>
</dxo-scheduler-appointment-dragging>
</dx-scheduler>
import { ChangeDetectionStrategy, Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { DxSchedulerModule, DxDraggableModule, DxScrollViewModule } from 'devextreme-angular';
import { DxSchedulerTypes } from 'devextreme-angular/ui/scheduler';
import { DxDraggableTypes } from 'devextreme-angular/ui/draggable';
import { Appointment, Task, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
changeDetection: ChangeDetectionStrategy.Eager,
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxSchedulerModule,
DxDraggableModule,
DxScrollViewModule,
],
})
export class AppComponent {
draggingGroupName = 'appointmentsGroup';
tasks: Task[];
appointments: Appointment[];
currentDate: Date = new Date(2021, 3, 26);
constructor(service: Service) {
this.tasks = service.getTasks();
this.appointments = service.getAppointments();
}
onAppointmentRemove = (e: DxSchedulerTypes.AppointmentDraggingRemoveEvent) => {
const index = this.appointments.indexOf(e.itemData);
if (index >= 0) {
this.appointments.splice(index, 1);
this.tasks.push(e.itemData);
}
};
onAppointmentAdd = (e: DxSchedulerTypes.AppointmentDraggingAddEvent) => {
const index = this.tasks.indexOf(e.fromData);
if (index >= 0) {
this.tasks.splice(index, 1);
this.appointments.push(e.itemData);
}
};
onListDragStart(e: DxDraggableTypes.DragStartEvent) {
e.cancel = true;
}
onItemDragStart(e: DxDraggableTypes.DragStartEvent) {
e.itemData = e.fromData;
}
onItemDragEnd(e: DxDraggableTypes.DragEndEvent) {
if (e.toData) {
e.cancel = true;
}
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
#scroll,
#list {
position: absolute;
left: 0;
top: 0;
bottom: 0;
width: 240px;
}
.item {
color: var(--dx-color-text);
background-color: var(--dx-component-color-bg);
display: block;
box-sizing: border-box;
padding: 10px 20px;
margin-bottom: 10px;
}
#scheduler {
margin-left: 270px;
}
.dx-draggable-source {
opacity: 0.5;
}
.dx-draggable-dragging > * {
box-shadow: 0 1px 3px rgba(0, 0, 0, 0.1), 0 6px 8px rgba(0, 0, 0, 0.2);
}
import { Injectable } from '@angular/core';
export class Appointment {
text: string;
startDate: Date;
endDate: Date;
allDay?: boolean;
}
export class Task {
text: string;
}
const appointments: Appointment[] = [
{
text: 'Book Flights to San Fran for Sales Trip',
startDate: new Date('2021-04-26T19:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
allDay: true,
}, {
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date('2021-04-27T17:00:00.000Z'),
endDate: new Date('2021-04-27T18:00:00.000Z'),
}, {
text: 'Final Budget Review',
startDate: new Date('2021-04-27T19:00:00.000Z'),
endDate: new Date('2021-04-27T20:35:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
startDate: new Date('2021-04-28T19:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
}, {
text: 'Customer Workshop',
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T19:00:00.000Z'),
allDay: true,
}, {
text: 'Prepare 2021 Marketing Plan',
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T20:30:00.000Z'),
},
];
const tasks: Task[] = [
{
text: 'New Brochures',
}, {
text: 'Brochure Design Review',
}, {
text: 'Upgrade Personal Computers',
}, {
text: 'Install New Router in Dev Room',
}, {
text: 'Upgrade Server Hardware',
}, {
text: 'Install New Database',
}, {
text: 'Website Re-Design Plan',
}, {
text: 'Create Icons for Website',
}, {
text: 'Submit New Website Design',
}, {
text: 'Launch New Website',
},
];
@Injectable()
export class Service {
getAppointments(): Appointment[] {
return appointments;
}
getTasks(): Task[] {
return tasks;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>